#include "universitystudent.hpp"
#include "course.hpp"
#include <cstdlib>
#include <ctime>
using namespace std;

UniversityStudent::UniversityStudent(const string& n) : _name(n)
{
    _neptunCode = generateCode();
    _neptunPassword = generatePassword();
}

string UniversityStudent::name() const
{
    return _name;
}

string UniversityStudent::neptunCode() const
{
    return _neptunCode;
}

const std::vector<Course*>& UniversityStudent::courses() const
{
    return _courses;
}

int UniversityStudent::numberOfCourses() const
{
    return _courses.size();
}

int UniversityStudent::numberOfCredits() const
{
    int c = 0;
    for (int i = 0; i < _courses.size(); i++)
        c += _courses[i]->credits();

    return c;
}

void UniversityStudent::newCourse(Course* c)
{
    if (c->newStudent(this)) // ha a kurzus felveszi a hallgatt
        _courses.push_back(c); // csak akkor veheti fel a hallgat a kurzust
}

string UniversityStudent::generateCode()
{
    srand(time(0));
    string code = "";
    for (int i = 0; i < 6; i++)
        code += rand() % 36 + 65;
    return code;
}

string UniversityStudent::generatePassword()
{
    srand(time(0));
    string pw = "";
    for (int i = 0; i < 8; i++)
        pw += rand() % 36 + 97;
    return pw;
}
